//+------------------------------------------------------------------+
//|                                                     Trigger Line |
//|                             Copyright  2005 dwt5 and adoleh2000 |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005 dwt5 and adoleh2000 "
#property  link      "http://www.metaquotes.net/"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 4            
#property indicator_color1 Magenta      
#property indicator_color2 Magenta
#property indicator_color3 Lime
#property indicator_color4 Lime




//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];



int width;

extern int Rperiod = 21;
extern int LSMA_Period = 5;
extern int BarstoDraw = 500;
int Draw4HowLong;
int shift;
int loopbegin;
int length;
int lsma_length;

double lengthvar;
double wt[];
double lsma_ma[];
int c;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 7 additional buffers are used for counting.
   IndicatorBuffers(6);   
   
//---- drawing settings
   
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,2);
  

   SetIndexBuffer(4,wt);         
   SetIndexBuffer(5,lsma_ma);
   

   
//---- initialization done
   return(0);
  }

int start()

  {   Draw4HowLong = BarstoDraw-Rperiod - 5;                            //Rperiod = 20
      length = Rperiod;                                           //length now = 20  
      lsma_length = LSMA_Period;
      loopbegin = Draw4HowLong - length - 1;  
       
   for(int i = 0; i < loopbegin; i++)
         wt[i] = iCustom(NULL,0,"LSMA",length,0,4,i);

      for(shift = loopbegin; shift >= 0; shift--)  //  MAIN For Loop
      { 
         lsma_ma[shift] =iMAOnArray(wt,0,lsma_length,0,MODE_EMA,shift);
                          
//========== COLOR CODING ===========================================                       
        
        
            ExtMapBuffer1[shift] = wt[shift]; 
            ExtMapBuffer2[shift] = lsma_ma[shift]; 
            ExtMapBuffer3[shift] = wt[shift]; 
            ExtMapBuffer4[shift] = lsma_ma[shift]; 
                    
                   
            
            if (wt[shift]  < lsma_ma[shift])
            {
                ExtMapBuffer4[shift] = EMPTY_VALUE;
                ExtMapBuffer3[shift] = EMPTY_VALUE;
            }          
            
       
        }
  }
//+------------------------------------------------------------------+



